/**
 * plugin.min.js
 *
 * Released under Attribution-ShareAlike 4.0 International License.
 * Author: Ignacio Gros (http://gros.es/) for http://exelearning.net/
 *
 * License: http://creativecommons.org/licenses/by-sa/4.0/
 */

/**
 * It just adds a <br style="clear:both" /> as a "clearfix" solution
 */
tinymce.PluginManager.add('clearfloat', function(editor, url) {
	
	editor.addButton('clearfloat', {
		tooltip: _("Clear (new line or block)"),
		image: url + '/img/clearfloat.png',
		onclick: function() {
			if (editor.selection.getContent()=="") {
				editor.execCommand('mceInsertContent', false, '<br style="clear:both" />', {skip_undo : 1});
			}
		}
	});
	
	editor.addMenuItem('clearfloat', {
		text: _("Clear (new line or block)"),
		image: url + '/img/clearfloat.png',
		context: 'insert',
		onclick: function() {
			if (editor.selection.getContent()=="") {
				editor.execCommand('mceInsertContent', false, '<br style="clear:both" />', {skip_undo : 1});
			}
		}
	});
	
});